//+------------------------------------------------------------------+
//|                                             asymmetric bands.mq4 |
//|                                                                  |
//| forex-tsd elite section only                                     |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  3
#property indicator_color1   DimGray
#property indicator_color2   Red
#property indicator_color3   LimeGreen
#property indicator_style1   STYLE_DOT

//
//
//
//
//

extern int    OmaBandsLength   = 50;
extern double OmaBandsSpeed    = 8.0;
extern bool   OmaBandsAdaptive = true;
extern int    bandsPrice       = PRICE_CLOSE;
extern double bandsDeviations  = 2;

//
//
//
//
//

double maBuffer[];
double upBuffer[];
double dnBuffer[];
double wuBuffer[];
double wdBuffer[];
double stored[][7];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,upBuffer);
   SetIndexBuffer(2,dnBuffer);
   SetIndexBuffer(3,wuBuffer);
   SetIndexBuffer(4,wdBuffer);
   OmaBandsLength = MathMax(OmaBandsLength,   1);
   OmaBandsSpeed  = MathMax(OmaBandsSpeed ,-1.5);
   
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      double price = iMA(NULL,0,1          ,0,MODE_SMA   ,bandsPrice,i);
      maBuffer[i]  = iAverage(iMA(NULL,0,1,0,MODE_SMA,bandsPrice,i),OmaBandsLength,OmaBandsSpeed,OmaBandsAdaptive,r);
    
         if (i==(Bars-1))
         {
            upBuffer[i] = maBuffer[i];
            dnBuffer[i] = maBuffer[i];
            wuBuffer[i] = price-maBuffer[i];
            wdBuffer[i] = price-maBuffer[i];
            continue;
         }
         
      //
      //
      //
      //
      //
      
         double diff = price-maBuffer[i];
         if(diff>=0)
            {
               wuBuffer[i] = (wuBuffer[i+1]*(OmaBandsLength-1)+MathPow(diff,2))/OmaBandsLength;
               wdBuffer[i] =  wdBuffer[i+1]*(OmaBandsLength-1)/OmaBandsLength;
            }
         else
            {
               wdBuffer[i] = (wdBuffer[i+1]*(OmaBandsLength-1)+MathPow(diff,2))/OmaBandsLength;
               wuBuffer[i] =  wuBuffer[i+1]*(OmaBandsLength-1)/OmaBandsLength;
            }
         upBuffer[i] = maBuffer[i] + bandsDeviations*MathSqrt(wuBuffer[i]);
         dnBuffer[i] = maBuffer[i] - bandsDeviations*MathSqrt(wdBuffer[i]);
   }
   return(0);
}


#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}

